ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.2 by root, Mon Dec 6 20:53:44 2010 UTC vs.
Revision 1.25 by root, Tue Dec 28 18:03:47 2010 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6PERLVER=5.12.2 # 5.8.9 is also a good choice
7STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
8CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
9EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
10 9
11MKBUNDLE="$STATICPERL/mkbundle"
12
13# perl build variables 10# perl build variables
14PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
14PERL_CONFIGURE="" # additional Configure arguments
15PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
17 17
18ARCH="$(uname -m)" 18ARCH="$(uname -m)"
19 19
20case "$ARCH" in 20case "$ARCH" in
28 ;; 28 ;;
29esac 29esac
30 30
31# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
32# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
33# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
34PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
36 36
37# some configuration options for modules 37# some configuration options for modules
38export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
40export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
41 42
42# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
43# required by mkbundle 44# required by mkbundle
44STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
45 46
46# which extra modules you might want to install 47# which extra modules you might want to install
47EXTRA_MODULES="" 48EXTRA_MODULES=""
48 49
49# overridable functions 50# overridable functions
51preconfigure() { : ; }
50postconfigure() { : ; } 52postconfigure() { : ; }
51postbuild() { : ; } 53postbuild() { : ; }
52postinstall() { : ; } 54postinstall() { : ; }
53 55
54# now source user config, if any 56# now source user config, if any
57if [ "$STATICPERLRC" ]; then
58 . "$STATICPERLRC"
59else
55[ -r /etc/staticperlrc ] && . /etc/staticperlrc 60 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
56[ -r ~/.staticperlrc ] && . ~/.staticperlrc 61 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
57[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 62 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
63fi
58 64
59############################################################################# 65#############################################################################
60# support 66# support
67
68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
70
71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
72LC_ALL=C; export LC_ALL # just to be on the safe side
61 73
62# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
63VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
64$VERSION=0.1 76$VERSION=0.92
65 77
66BZ2=bz2 78BZ2=bz2
67BZIP2=bzip2 79BZIP2=bzip2
68 80
69fatal() { 81fatal() {
102############################################################################# 114#############################################################################
103# clean 115# clean
104 116
105distclean() { 117distclean() {
106 verblock <<EOF 118 verblock <<EOF
107deleting everything installed by this script 119 deleting everything installed by this script (rm -rf $STATICPERL)
108EOF 120EOF
109 121
110 rm -rf "$STATICPERL" 122 rm -rf "$STATICPERL"
111} 123}
112 124
113############################################################################# 125#############################################################################
114# download/configure/compile/install perl 126# download/configure/compile/install perl
115 127
116clean() { 128clean() {
117 cd "$STATICPERL/src/perl-$PERLVER" 2>/dev/null || return 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
130}
118 131
119 rm -f staticstamp.configure 132realclean() {
120 make distclean >/dev/null 2>&1 133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
121} 136}
122 137
123fetch() { 138fetch() {
124 rcd "$STATICPERL" 139 rcd "$STATICPERL"
125 140
126 mkdir -p src 141 mkdir -p src
127 rcd src 142 rcd src
128 143
129 if ! [ -d "perl-$PERLVER" ]; then 144 if ! [ -d "perl-$PERL_VERSION" ]; then
130 if ! [ -e "perl-$PERLVER.tar.$BZ2" ]; then 145 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then
131 146
132 URL="$CPAN/src/5.0/perl-$PERLVER.tar.$BZ2" 147 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2"
133 148
134 verblock <<EOF 149 verblock <<EOF
135downloading perl 150downloading perl
136to manually download perl yourself, place 151to manually download perl yourself, place
137perl-$PERLVER.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
138trying $URL 153trying $URL
139EOF 154EOF
140 155
156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
141 curl >perl-$PERLVER.tar.$BZ2~ "$URL" \ 157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
142 || wget -O perl-$PERLVER.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
143 || fatal "$URL: error during downloading" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
144 mv perl-$PERLVER.tar.$BZ2~ perl-$PERLVER.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
145 fi 162 fi
146 163
147 verblock <<EOF 164 verblock <<EOF
148unpacking perl 165unpacking perl
149EOF 166EOF
150 167
151 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
152 $BZIP2 -d <perl-$PERLVER.tar.bz2 | tar xpC unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
153 || fatal "perl-$PERLVER.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
172 chmod -R u+w unpack/perl-$PERL_VERSION
154 mv unpack/perl-$PERLVER perl-$PERLVER 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
155 rmdir -p unpack 174 rmdir -p unpack
156 fi 175 fi
157} 176}
158 177
159# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
160sedreplace() { 179sedreplace() {
161 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
162 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
163} 209}
164 210
165configure() { 211configure() {
166 fetch 212 fetch
167 213
168 rcd "$STATICPERL/src/perl-$PERLVER" 214 rcd "$STATICPERL/src/perl-$PERL_VERSION"
169 215
170 [ -e staticstamp.configure ] && return 216 [ -e staticstamp.configure ] && return
171 217
172 verblock <<EOF 218 verblock <<EOF
173configuring $STATICPERL/src/perl-$PERLVER 219configuring $STATICPERL/src/perl-$PERL_VERSION
174EOF 220EOF
175 221
176 clean
177
178 rm -f "$PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
179 223
224 "$MAKE" distclean >/dev/null 2>&1
225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
180 # I hate them 228 # I hate them for this
181 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
182 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
231
232 preconfigure
183 233
184# trace configure \ 234# trace configure \
185 sh Configure -Duselargefiles \ 235 sh Configure -Duselargefiles \
186 -Uuse64bitint \ 236 -Uuse64bitint \
187 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
188 -Uusedl \ 238 -Uusedl \
189 -Uusethreads \ 239 -Uusethreads \
190 -Uuseithreads \ 240 -Uuseithreads \
191 -Uusemultiplicity \ 241 -Uusemultiplicity \
192 -Duseperlio \
193 -Uusesfio \ 242 -Uusesfio \
194 -Uuseshrplib \ 243 -Uuseshrplib \
195 -Dcppflags="$PERL_CPPFLAGS" \ 244 -A ccflags=" $PERL_CCFLAGS" \
196 -Dccflags="-g2 -fno-strict-aliasing" \ 245 -Dcc="$PERL_CC" \
197 -Doptimize="$PERL_OPTIMIZE" \ 246 -Doptimize="$PERL_OPTIMIZE" \
198 -Dldflags="$PERL_LDFLAGS" \ 247 -Dldflags="$PERL_LDFLAGS" \
199 -Dlibs="$PERL_LIBS" \ 248 -Dlibs="$PERL_LIBS" \
200 -Dprefix="$PREFIX" \ 249 -Dprefix="$PERL_PREFIX" \
201 -Dbin="$PREFIX/bin" \ 250 -Dbin="$PERL_PREFIX/bin" \
202 -Dprivlib="$PREFIX/lib" \ 251 -Dprivlib="$PERL_PREFIX/lib" \
203 -Darchlib="$PREFIX/lib" \ 252 -Darchlib="$PERL_PREFIX/lib" \
204 -Uusevendorprefix \ 253 -Uusevendorprefix \
205 -Dsitelib="$PREFIX/lib" \ 254 -Dsitelib="$PERL_PREFIX/lib" \
206 -Dsitearch="$PREFIX/lib" \ 255 -Dsitearch="$PERL_PREFIX/lib" \
207 -Usitelibexp \
208 -Uman1dir \ 256 -Uman1dir \
209 -Uman3dir \ 257 -Uman3dir \
210 -Usiteman1dir \ 258 -Usiteman1dir \
211 -Usiteman3dir \ 259 -Usiteman3dir \
212 -Dpager=/usr/bin/less \ 260 -Dpager=/usr/bin/less \
213 -Demail="$EMAIL" \ 261 -Demail="$EMAIL" \
214 -Dcf_email="$EMAIL" \ 262 -Dcf_email="$EMAIL" \
215 -Dcf_by="$EMAIL" \ 263 -Dcf_by="$EMAIL" \
264 $PERL_CONFIGURE \
265 -Duseperlio \
216 -dE || fatal "Configure failed" 266 -dE || configure_failure
217 267
218 sedreplace ' 268 sedreplace '
219 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 269 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
220 s/ *-fno-stack-protector */ /g 270 s/ *-fno-stack-protector */ /g
221 ' config.sh 271 ' config.sh
228} 278}
229 279
230build() { 280build() {
231 configure 281 configure
232 282
233 rcd "$STATICPERL/src/perl-$PERLVER" 283 rcd "$STATICPERL/src/perl-$PERL_VERSION"
234 284
235 verblock <<EOF 285 verblock <<EOF
236building $STATICPERL/src/perl-$PERLVER 286building $STATICPERL/src/perl-$PERL_VERSION
237EOF 287EOF
238 288
239 rm -f "$PREFIX/staticstamp.install" 289 rm -f "$PERL_PREFIX/staticstamp.install"
240 290
241 make || fatal "make: error while building perl" 291 "$MAKE" || fatal "make: error while building perl"
242 292
243 postbuild || fatal "postbuild hook failed" 293 postbuild || fatal "postbuild hook failed"
244} 294}
245 295
246install() { 296install() {
247 [ -e "$PREFIX/staticstamp.install" ] && return 297 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
248
249 build 298 build
250 299
251 verblock <<EOF 300 verblock <<EOF
252installing $STATICPERL/src/perl-$PERLVER 301installing $STATICPERL/src/perl-$PERL_VERSION
253to $PREFIX 302to $PERL_PREFIX
254EOF 303EOF
255 304
256 rm -rf "$PREFIX" 305 ln -sf "perl/bin/" "$STATICPERL/bin"
257 306 ln -sf "perl/lib/" "$STATICPERL/lib"
307
308 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
309 rm -rf "$PERL_PREFIX" # by this rm -rf
310
258 make install || fatal "make install: error while installing" 311 "$MAKE" install || fatal "make install: error while installing"
259 312
260 rcd "$PREFIX" 313 rcd "$PERL_PREFIX"
261 314
262 # create a "make install" replacement for CPAN 315 # create a "make install" replacement for CPAN
263 cat >"$PREFIX"/bin/cpan-make-install <<EOF 316 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
264make install UNINST=1 317"$MAKE" || exit
318
265if find blib/arch/auto -type f | grep -q -v .exists; then 319if find blib/arch/auto -type f | grep -q -v .exists; then
266 echo Probably an XS module, rebuilding perl 320 echo Probably an XS module, rebuilding perl
267 make perl 321 if "$MAKE" perl; then
322 mv perl "$PERL_PREFIX"/bin/perl~ \
268 rm -f "$PREFIX"/bin/perl 323 && rm -f "$PERL_PREFIX"/bin/perl \
269 make -f Makefile.aperl inst_perl 324 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
270 make -f Makefile.aperl map_clean 325 "$MAKE" -f Makefile.aperl map_clean
326 else
327 "$MAKE" -f Makefile.aperl map_clean
328 exit 1
329 fi
271fi 330fi
331
332"$MAKE" install UNINST=1
272EOF 333EOF
273 chmod 755 "$PREFIX"/bin/cpan-make-install 334 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
274 335
275 # try to trick CPAN into avoiding ~/.cpan completely 336 # trick CPAN into avoiding ~/.cpan completely
276 echo 1 >"$PREFIX/lib/CPAN/MyConfig.pm" 337 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
277 338
278 "$PREFIX"/bin/perl -MCPAN -e ' 339 "$PERL_PREFIX"/bin/perl -MCPAN -e '
279 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 340 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
280 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 341 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
281 CPAN::Shell->o (conf => q<init>); 342 CPAN::Shell->o (conf => q<init>);
282 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 343 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
283 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 344 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
284 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 345 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
285 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 346 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
286 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 347 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
287 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PREFIX"'/bin/cpan-make-install"); 348 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
288 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 349 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
289 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 350 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
290 CPAN::Shell->o (conf => q<commit>); 351 CPAN::Shell->o (conf => q<commit>);
291 ' || fatal "error while initialising CPAN" 352 ' || fatal "error while initialising CPAN"
292 353
354 touch "$PERL_PREFIX/staticstamp.install"
355 fi
356
357 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
293 NOCHECK_INSTALL=+ 358 NOCHECK_INSTALL=+
294 instcpan $STATICPERL_MODULES 359 instcpan $STATICPERL_MODULES
295 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 360 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
296 361
297 postinstall || fatal "postinstall hook failed" 362 postinstall || fatal "postinstall hook failed"
298 363
299 touch "$PREFIX/staticstamp.install" 364 touch "$PERL_PREFIX/staticstamp.postinstall"
365 fi
300} 366}
301 367
302############################################################################# 368#############################################################################
303# install a module from CPAN 369# install a module from CPAN
304 370
309installing modules from CPAN 375installing modules from CPAN
310$@ 376$@
311EOF 377EOF
312 378
313 for mod in "$@"; do 379 for mod in "$@"; do
314 "$PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 380 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \
315 || fatal "$mod: unable to install from CPAN" 381 || fatal "$mod: unable to install from CPAN"
316 done 382 done
317 rm -rf "$STATICPERL/build" 383 rm -rf "$STATICPERL/build"
318} 384}
319 385
331 for mod in "$@"; do 397 for mod in "$@"; do
332 echo 398 echo
333 echo $mod 399 echo $mod
334 ( 400 (
335 rcd $mod 401 rcd $mod
336 make -f Makefile.aperl map_clean >/dev/null 2>&1 402 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
337 make distclean >/dev/null 2>&1 403 "$MAKE" distclean >/dev/null 2>&1
338 "$PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 404 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
339 make || fatal "$mod: error building module" 405 "$MAKE" || fatal "$mod: error building module"
340 "$PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 406 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
341 make distclean >/dev/null 2>&1 407 "$MAKE" distclean >/dev/null 2>&1
342 exit 0 408 exit 0
343 ) || exit $? 409 ) || exit $?
344 done 410 done
345} 411}
346 412
347############################################################################# 413#############################################################################
348# do schmorpy stuff
349
350MODSRCDIR=~/src
351
352instmodsrc() {
353 for mod in "$@"; do
354 instmod_src "$MODSRCDIR/$mod"
355 done
356}
357
358install_schmorp() {
359 install
360
361 instcpan Data::Dump Term::ReadLine::Perl Term::ANSIColor Term::ReadKey
362 instcpan Digest::SHA Digest::MD6 Digest::SHA256 Digest::MD4 Digest::HMAC_MD5 Digest::HMAC_MD6 Digest::FNV
363 #instcpan Net::SSLeay # requires static -ldl
364
365 instmodsrc common-sense Crypt-Twofish2 Array-Heap Convert-Scalar Compress-LZF JSON-XS
366 instmodsrc EV Guard Async-Interrupt IO-AIO
367 instmodsrc AnyEvent AnyEvent-AIO Coro AnyEvent-HTTP
368 instmodsrc Linux-Inotify2 EV-Loop-Async
369
370 instcpan AnyEvent::HTTPD
371}
372
373#############################################################################
374# main 414# main
375 415
376podusage() { 416podusage() {
377 echo 417 echo
418
378 if [ -e "$PREFIX/bin/perl" ]; then 419 if [ -e "$PERL_PREFIX/bin/perl" ]; then
379 "$PREFIX/bin/perl" -MPod::Usage -e \ 420 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
380 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 421 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
381 2>/dev/null && exit 422 2>/dev/null && exit
382 fi 423 fi
424
383 # try whatever perl we can find 425 # try whatever perl we can find
384 perl -MPod::Usage -e \ 426 perl -MPod::Usage -e \
385 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 427 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
386 2>/dev/null && exit 428 2>/dev/null && exit
387 429
388 fatal "displaying documentation requires a working perl - try '$0 install' first" 430 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
389} 431}
390 432
391usage() { 433usage() {
392 podusage 0 434 podusage 0
393} 435}
394 436
395catmkbundle() { 437catmkbundle() {
396 { 438 {
397 read dummy 439 read dummy
398 echo "#!$PREFIX/bin/perl" 440 echo "#!$PERL_PREFIX/bin/perl"
399 cat 441 cat
400 } <<'MKBUNDLE' 442 } <<'MKBUNDLE'
401#CAT mkbundle 443#CAT mkbundle
402MKBUNDLE 444MKBUNDLE
403} 445}
404 446
405bundle() { 447bundle() {
406 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 448 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
407 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 449 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
450 CACHE="$STATICPERL/cache"
451 mkdir -p "$CACHE"
408 "$PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 452 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
409} 453}
410 454
411if [ $# -gt 0 ]; then 455if [ $# -gt 0 ]; then
412 while [ $# -gt 0 ]; do 456 while [ $# -gt 0 ]; do
413 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 457 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
414 mkdir -p "$PREFIX" || fatal "$PREFIX: cannot create" 458 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
415 459
416 command="${1#--}"; shift 460 command="${1#--}"; shift
417 case "$command" in 461 case "$command" in
462 version )
463 echo "staticperl version $VERSION"
464 ;;
418 fetch | configure | build | install | clean | distclean) 465 fetch | configure | build | install | clean | realclean | distclean)
419 verblock <<EOF
420$command
421EOF
422 "$command" 466 ( "$command" ) || exit
423 ;; 467 ;;
424 instsrc ) 468 instsrc )
425 instsrc "$@" 469 ( instsrc "$@" ) || exit
426 exit 470 exit
427 ;; 471 ;;
428 instcpan ) 472 instcpan )
429 instcpan "$@" 473 ( instcpan "$@" ) || exit
430 exit 474 exit
431 ;; 475 ;;
432 instschmorp )
433 install_schmorp
434 ;;
435 cpan ) 476 cpan )
436 install 477 ( install ) || exit
437 "$PREFIX/bin/cpan" "$@" 478 "$PERL_PREFIX/bin/cpan" "$@"
438 exit 479 exit
439 ;; 480 ;;
440 mkbundle ) 481 mkbundle )
441 install 482 ( install ) || exit
442 bundle "$@" 483 bundle "$@"
443 exit 484 exit
444 ;; 485 ;;
445 mkperl ) 486 mkperl )
446 install 487 ( install ) || exit
447 bundle --perl "$@" 488 bundle --perl "$@"
489 exit
490 ;;
491 mkapp )
492 ( install ) || exit
493 bundle --app "$@"
448 exit 494 exit
449 ;; 495 ;;
450 help ) 496 help )
451 podusage 2 497 podusage 2
452 ;; 498 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines